/*
    Copyright © 2020-2023, Inochi2D Project
    Copyright ©      2024, nijigenerate Project
    Distributed under the 2-Clause BSD License, see LICENSE file.
    
    Authors: Luna Nielsen
*/
module nijigenerate.panels.animlist;
import nijigenerate.panels;
import nijigenerate : EditMode;
import i18n;
import bindbc.imgui;
import nijigenerate;
import std.string;
import nijilive;
import nijigenerate.widgets;
import nijigenerate.windows;

/**
    The logger frame
*/
class AnimListPanel : Panel {
private:

protected:
    override
    void onUpdate() {
        auto canim = incAnimationGet();
        string currAnimName = canim ? canim.name : "";

        if (igBeginChild("ANIM_LIST", ImVec2(0, -32), true)) {
            foreach(name, ref anim; incActivePuppet().getAnimations()) {
                igPushID(name.ptr, name.ptr+name.length);
                    if (igBeginPopup("###OPTIONS")) {
                        if (igMenuItem(__("Edit..."))) {
                            incPushWindow(new EditAnimationWindow(anim, name));
                        }
                        if (igMenuItem(__("Delete"))) {
                            incActivePuppet().getAnimations().remove(name);
                            igEndPopup();
                            igPopID();
                            igEndChild();
                            return;
                        }
                        igEndPopup();
                    }

                    if (igSelectable(name.toStringz, name == currAnimName)) {
                        incAnimationChange(name);
                    }

                    igOpenPopupOnItemClick("###OPTIONS", ImGuiPopupFlags.MouseButtonRight);
                igPopID();
            }
        }
        igEndChild();

        incDummy(ImVec2(0, 2));

        if (igBeginChild("ANIM_BTNS", ImVec2(0, 0), false, ImGuiWindowFlags.NoScrollbar | ImGuiWindowFlags.NoScrollWithMouse)) {

            incDummy(ImVec2(-26, 0));
            igSameLine(0, 0);

            if (incButtonColored("", ImVec2(24, 24))) {
                incPushWindow(new EditAnimationWindow());
            }
        }
        igEndChild();
    }

public:
    this() {
        super("Animation List", _("Animation List"), false);
        activeModes = EditMode.AnimEdit;
    }
}

/**
    Generate logger frame
*/
mixin incPanel!AnimListPanel;


